GDB (xrefs)

Enumerations | Functions | Variables
mi-cmd-stack.c File Reference
`#include "defs.h"`
`#include "target.h"`
`#include "frame.h"`
`#include "value.h"`
`#include "mi-cmds.h"`
`#include "ui-out.h"`
`#include "symtab.h"`
`#include "block.h"`
`#include "stack.h"`
`#include "dictionary.h"`
`#include "language.h"`
`#include "valprint.h"`
`#include "utils.h"`
`#include "mi-getopt.h"`
`#include "extension.h"`
`#include <ctype.h>`
`#include "mi-parse.h"`
`#include "common/gdb_optional.h"`

Go to the source code of this file.

## Enumerations
enum | what_to_list { locals, arguments, all }

## Functions
static void | list_args_or_locals (enum what_to_list what, enum print_values values, struct frame_info *fi, int skip_unavailable)
void | mi_cmd_enable_frame_filters (const char *command, char **argv, int argc)
static enum ext_lang_bt_status | mi_apply_ext_lang_frame_filter (struct frame_info *frame, int flags, enum print_values print_values, struct ui_out *out, int frame_low, int frame_high)
void | mi_cmd_stack_list_frames (const char *command, char **argv, int argc)
void | mi_cmd_stack_info_depth (const char *command, char **argv, int argc)
void | mi_cmd_stack_list_locals (const char *command, char **argv, int argc)
void | mi_cmd_stack_list_args (const char *command, char **argv, int argc)
void | mi_cmd_stack_list_variables (const char *command, char **argv, int argc)
static void | list_arg_or_local (const struct frame_arg *arg, enum what_to_list what, enum print_values values, int skip_unavailable)
void | mi_cmd_stack_select_frame (const char *command, char **argv, int argc)
void | mi_cmd_stack_info_frame (const char *command, char **argv, int argc)

## Variables
static int | frame_filters = 0

## Enumeration Type Documentation

## ◆ what_to_list

enum what_to_list

Enumerator
locals |
arguments |
all |

Definition at line 39 of file mi-cmd-stack.c.

## Function Documentation

## ◆ list_arg_or_local()

static void list_arg_or_local | ( | const struct frame_arg * | arg,
|  | enum what_to_list | what,
|  | enum print_values | values,
|  | int | skip_unavailable
| ) |  |
| static

Definition at line 478 of file mi-cmd-stack.c.

References _, all, CATCH, check_typedef(), common_val_print(), current_uiout, value_print_options::deref_ref, gdb::optional< T >::emplace(), END_CATCH, frame_arg::entry_kind, frame_arg::error, ui_out::field_int(), ui_out::field_stream(), gdb_assert, get_no_prettyformat_print_options(), language_def(), PRINT_ALL_VALUES, print_entry_values_no, print_entry_values_only, PRINT_NO_VALUES, PRINT_SIMPLE_VALUES, ui_file::printf(), ui_file::puts(), RETURN_MASK_ERROR, frame_arg::sym, SYMBOL_IS_ARGUMENT, SYMBOL_LANGUAGE, SYMBOL_PRINT_NAME, TRY, symbol::type, TYPE_LENGTH, type_print(), frame_arg::val, val_print_scalar_type_p(), value_bytes_available(), value_embedded_offset(), value_entirely_unavailable(), and value_type().

Referenced by list_args_or_locals().

## ◆ list_args_or_locals()

static void list_args_or_locals | ( | enum what_to_list | what,
|  | enum print_values | values,
|  | struct frame_info * | fi,
|  | int | skip_unavailable
| ) |  |
| static

Definition at line 561 of file mi-cmd-stack.c.

References all, ALL_BLOCK_SYMBOLS, arguments, BLOCK_FUNCTION, BLOCK_SUPERBLOCK, check_typedef(), current_uiout, frame_arg::entry_kind, frame_arg::error, gdb_assert, get_frame_block(), internal_error(), list_arg_or_local(), LOC_ARG, LOC_BLOCK, LOC_COMPUTED, LOC_CONST, LOC_CONST_BYTES, LOC_LABEL, LOC_LOCAL, LOC_OPTIMIZED_OUT, LOC_REF_ARG, LOC_REGISTER, LOC_REGPARM_ADDR, LOC_STATIC, LOC_TYPEDEF, LOC_UNDEF, LOC_UNRESOLVED, locals, lookup_symbol(), memset(), PRINT_ALL_VALUES, print_entry_values_no, print_entry_values_only, PRINT_SIMPLE_VALUES, read_frame_arg(), read_frame_local(), frame_arg::sym, block_symbol::symbol, SYMBOL_CLASS, SYMBOL_IS_ARGUMENT, SYMBOL_LINKAGE_NAME, type, symbol::type, TYPE_CODE, TYPE_CODE_ARRAY, TYPE_CODE_STRUCT, TYPE_CODE_UNION, VAR_DOMAIN, and xfree().

Referenced by mi_cmd_stack_list_args(), mi_cmd_stack_list_locals(), and mi_cmd_stack_list_variables().

## ◆ mi_apply_ext_lang_frame_filter()

static enum ext_lang_bt_status mi_apply_ext_lang_frame_filter | ( | struct frame_info * | frame,
|  | int | flags,
|  | enum print_values | print_values,
|  | struct ui_out * | out,
|  | int | frame_low,
|  | int | frame_high
| ) |  |
| static

Definition at line 60 of file mi-cmd-stack.c.

References apply_ext_lang_frame_filter(), and flags.

Referenced by mi_cmd_stack_list_args(), mi_cmd_stack_list_locals(), and mi_cmd_stack_list_variables().

## ◆ mi_cmd_enable_frame_filters()

void mi_cmd_enable_frame_filters | ( | const char * | command,
|  | char ** | argv,
|  | int | argc
| ) |  |

Definition at line 50 of file mi-cmd-stack.c.

References _, error(), and frame_filters.

## ◆ mi_cmd_stack_info_depth()

void mi_cmd_stack_info_depth | ( | const char * | command,
|  | char ** | argv,
|  | int | argc
| ) |  |

Definition at line 182 of file mi-cmd-stack.c.

References _, gdb::argv, current_uiout, error(), get_current_frame(), get_prev_frame(), and QUIT.

## ◆ mi_cmd_stack_info_frame()

void mi_cmd_stack_info_frame | ( | const char * | command,
|  | char ** | argv,
|  | int | argc
| ) |  |

Definition at line 689 of file mi-cmd-stack.c.

References _, error(), get_selected_frame(), LOC_AND_ADDRESS, and print_frame_info().

## ◆ mi_cmd_stack_list_args()

void mi_cmd_stack_list_args | ( | const char * | command,
|  | char ** | argv,
|  | int | argc
| ) |  |

Definition at line 285 of file mi-cmd-stack.c.

References _, arguments, gdb::argv, current_uiout, error(), EXT_LANG_BT_ERROR, EXT_LANG_BT_NO_FILTERS, ui_out::field_int(), flags, frame_filters, get_current_frame(), get_prev_frame(), list_args_or_locals(), mi_apply_ext_lang_frame_filter(), mi_getopt_allow_unknown(), mi_parse_print_values(), PRINT_ARGS, PRINT_LEVEL, and QUIT.

## ◆ mi_cmd_stack_list_frames()

void mi_cmd_stack_list_frames | ( | const char * | command,
|  | char ** | argv,
|  | int | argc
| ) |  |

Definition at line 80 of file mi-cmd-stack.c.

References _, apply_ext_lang_frame_filter(), gdb::argv, current_uiout, error(), EXT_LANG_BT_ERROR, EXT_LANG_BT_NO_FILTERS, flags, frame_filters, get_current_frame(), get_prev_frame(), LOC_AND_ADDRESS, mi_getopt(), NO_VALUES, PRINT_FRAME_INFO, print_frame_info(), PRINT_LEVEL, and QUIT.

## ◆ mi_cmd_stack_list_locals()

void mi_cmd_stack_list_locals | ( | const char * | command,
|  | char ** | argv,
|  | int | argc
| ) |  |

Definition at line 211 of file mi-cmd-stack.c.

References _, gdb::argv, current_uiout, error(), EXT_LANG_BT_ERROR, EXT_LANG_BT_NO_FILTERS, flags, frame_filters, get_selected_frame(), list_args_or_locals(), locals, mi_apply_ext_lang_frame_filter(), mi_getopt(), mi_parse_print_values(), PRINT_LEVEL, PRINT_LOCALS, and print_value().

## ◆ mi_cmd_stack_list_variables()

void mi_cmd_stack_list_variables | ( | const char * | command,
|  | char ** | argv,
|  | int | argc
| ) |  |

Definition at line 400 of file mi-cmd-stack.c.

References _, all, gdb::argv, current_uiout, error(), EXT_LANG_BT_ERROR, EXT_LANG_BT_NO_FILTERS, flags, frame_filters, get_selected_frame(), list_args_or_locals(), mi_apply_ext_lang_frame_filter(), mi_getopt(), mi_parse_print_values(), PRINT_ARGS, PRINT_LEVEL, PRINT_LOCALS, and print_value().

## ◆ mi_cmd_stack_select_frame()

void mi_cmd_stack_select_frame | ( | const char * | command,
|  | char ** | argv,
|  | int | argc
| ) |  |

Definition at line 680 of file mi-cmd-stack.c.

References _, gdb::argv, error(), and select_frame_command().

## Variable Documentation

## ◆ frame_filters

int frame_filters = 0
| static

Definition at line 47 of file mi-cmd-stack.c.

Referenced by mi_cmd_enable_frame_filters(), mi_cmd_stack_list_args(), mi_cmd_stack_list_frames(), mi_cmd_stack_list_locals(), and mi_cmd_stack_list_variables().